Program Feladatsor_373_varians;
(*
  Feladat:
    Ismert egy iskola tanulinak nvsora s szemlyi szma.
    Csoportostsa kln a lnyokat s a fikat!
    Adja meg: ki a legidsebb lny s fi, s milyen korak.
  Megoldas:
  0. Ttelek
     = Sztvlogats (szem.szam elso jegye szerint)
     + Max kivlasztsok
  1. Specifikaci:
     Be: N:Egesz, Iskola:(Nev x SzemSzam)^*, Nev=Szoveg, Szemszam=Szoveg^11
     Ki: lDb,fDb:Egesz, lany,fiu:(Nev x SzemSzam)^*
         lIdos,fIdos:Egesz, lKor,fKor:Egesz
     Ef: N=Hossz(Iskola)
     Uf: lDb=SUM(i=1..N)( KHI( Iskola(i).SzemSzam(1)=2 ) ) ES
         lany:=(Nev x SzemSzam)^lDb  ES  lany <= Iskola  ES
         BARMELY i:[1,lDb]: lany(i).SzemSzam(1)=1  ES
         BARMELY i:[1,lDb]: Kor(lany(i).SzemSzam)<Kor(lany(lIdos).SzemSzam)  ES
         Kor(lany(lIdos).SzemSzam)=lKor  ES
         ... a fiukra hasonloan ...
     Def: Kor: SzemSzam --> Egesz
          Kor(sz):=Egesz(sz(2..7))
*)
  Uses  Crt22,Dos{Idokezeles};
  Const MaxN=250;
        NevHossz=10;
  Type  TNev=String[40];
        TSzemSzam=String[11];
        TTanulo=Record
                  nev:TNev;
                  szemSzam:TSzemSzam
                End;
        TIskola=Array [1..MaxN] of TTanulo;
  Var   N,
        lDb,fDb:LongInt; {LongInt a datum-konverzio miatt}
        Iskola,
        lany,fiu:TIskola;
        lIdos,fIdos,
        lKor,fKor:LongInt; {LongInt a datum-konverzio miatt}

  Function Kor(szsz:TSzemSzam):LongInt; {Napokban merve}
    Var x1,x2,
        maNap,daNap:LongInt;
        da,ma:DateTime;
        y,m,d,dow:Word;
        hiba:Integer;
  Begin
  (*
    Val('19'+Copy(szsz,2,2),da.year,hiba);
    Val(Copy(szsz,4,2),da.month,hiba);
    Val(Copy(szsz,6,2),da.day,hiba);
    da.hour:=0; da.min:=0; da.sec:=0;
    PackTime(da,daNap);
    ma.year:=1999; ma.month:=12; ma.day:=31;
    ma.hour:=0; ma.min:=0; ma.sec:=0;
    PackTime(ma,maNap);
    Kor:=(maNap-daNap) Div (24*60*60*10*10)-132;
  *)
    Val('19'+Copy(szsz,2,2),da.year,hiba);
    Val(Copy(szsz,4,2),da.month,hiba);
    Val(Copy(szsz,6,2),da.day,hiba);
    GetDate(y,m,d,dow);
    Kor:=(y-da.year)
  End;

  Procedure Listazas(cim:String; t:TIskola; db:LongInt);
    Var i,j:Integer;
  Begin
    UjLap(cim,0{nem vr});
    For i:=1 to db do
    Begin
      Writeln(t[i].Nev:40,' (',t[i].szemszam,') ',Kor(t[i].szemszam):3);
    End;{For i}
  End;

  Procedure AdatBeolvasas;
    Var i,j:Integer;
        be:String;
  Begin
    (*
      Beolvass a specifiklt inputrl [l. a Crt22 unit lerst!]:
      Figyelem:
        ha a file-input hibs, akkor "vgtelen ciklusba" eshet...
    *)
    UjLap('Iskolai adatbzis',0{nem vr});
    Repeat
      Write('Tanulk szma:');
      Readln(N);
    Until N in [1..MaxN];
    For i:=1 to N do
    Begin
      Writeln(i:2,'. tanul neve s szemlyi szma ',
                  ' (Kln sorokban, utols utn res sor):');
      Repeat
        Write(' Neve:');
        Readln(Iskola[i].Nev);
      Until (Iskola[i].Nev>'') {ellenrizend lenne az egyedisg is!!!};
      Repeat
        Write('Szemlyi szma:');
        Readln(Iskola[i].szemSzam);
      Until Iskola[i].szemSzam>'' {ellenrizend lenne a helyessg is!!!};
    End;

    {Ellenrz kirs a kpernyre:}
    KonzolOutput;
    Listazas('Iskola',Iskola,N);
    BillreVar;
    {Visszavlts az esetleges file-outputra:}
    FileOutput('');

  End;

  Procedure EredmenyKiiras;
  Begin
    (*
      Kirs a specifiklt outputra.
      Azaz ha van outputfile specifiklva, akkor ttrs arra;
      klnben marad a konzoloutput.
    *)
    UjLap('Eredmny',0{billre vr});
    Listazas('Lnyok',lany,lDb);
    BillreVar;
    Listazas('Fik',fiu,fDb);
    BillreVar;
    Writeln(CrLf,'Legidsb lny: ',Iskola[lIdos].Nev,' (',Iskola[lIdos].SzemSzam,') ');
    Writeln('  Kora:',lKor);
    Writeln(CrLf,'Legidsb fi: ',Iskola[fIdos].Nev,' (',Iskola[fIdos].SzemSzam,') ');
    Writeln('  Kora:',fKor);
    BillreVar;
  End;

  Procedure Szetvalogatas(Var t:TIskola; db:LongInt;
                          Var l:TIskola; Var lDb:LongInt;
                          Var f:TIskola; Var fDb:LongInt);
    Var i:Integer;
  Begin
    lDb:=0; fDb:=0;
    For i:=1 to db do
    Begin
      If t[i].SzemSzam[1]='2' then
      Begin
        Inc(lDb); lany[lDb]:=t[i]
      End
        Else
      Begin
        Inc(fDb); fiu[fDb]:=t[i]
      End
    End;
  End;

  Procedure LegidosebbKereses(Var t:TIskola; db:Integer;
                              Var ki,kora:LongInt;
                              elsoJegy:Char);
    Var i:Integer;
  Begin  {Ef: Van olyan elem, amelyik elsoJeggyel kezdodik}
    kora:=-1;
    For i:=1 to db do
    Begin
      If t[i].SzemSzam[1]=elsoJegy then
        If kora<Kor(t[i].SzemSzam) then
        Begin
          kora:=Kor(t[i].SzemSzam); ki:=i
        End
      {EndIf}
    End;
  End;

Begin
  {Adatbeolvass file-bl v. konzolrl:}
  AdatBeolvasas;
  {Feldolgozs:}
  Szetvalogatas(Iskola,N,lany,lDb,fiu,fDb);
  LegidosebbKereses(Iskola,N,lIdos,lKor,'2'{SzemSzam-kezdet});
  LegidosebbKereses(Iskola,N,fIdos,fKor,'1'{SzemSzam-kezdet});
  {Kirs file-ba v. konzolra:}
  EredmenyKiiras;
End.